<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Homework 2.1</title>
</head>

<body>
  <div>
    <input id="csv" type="file" accept=".tsv" />
  </div>
  <script>
    "use strict";
    let file;

    const onChange = (e) => {
      file = e.target.files[0];
      processData();
    }
    document.getElementById('csv').addEventListener('change', onChange);

    const isCounted = (elem, ref) => elem === ref;

    const getPercentage = (ref, array) => {
      const totalData = array.length;
      const _ref = ref.toLowerCase();
      let count = 0;

      array.forEach(elem => isCounted(elem.toLowerCase(), _ref) && ++count);

      return count * 100 / totalData;
    };

    const getAbsoluteFrequency = (ref, array) => {
      const _ref = ref.toLowerCase();
      let count = 0;

      array.forEach(elem => isCounted(elem.toLowerCase(), _ref) && ++count);

      return count;
    };

    const getRelativeFrequency = (ref, array) => {
      const totalData = array.length;
      const _ref = ref.toLowerCase();
      let count = 0;

      array.forEach(elem => isCounted(elem.toLowerCase(), _ref) && ++count);

      return count / totalData;
    };

    const processData = () => {
      const reader = new FileReader();

      reader.onload = (e) => {
        const csvData = e.target.result;

        let csv = csvData.split('\n')
        csv = csv.map(elem => elem.split('\t'));

        const _csv = csv.slice(1);

        const header = [
          'Absolute Frequency',
          'Relative Frequency',
          'Percentage'
        ];

        const columnIndex1 = 23;
        const columnIndex2 = 5;
        const columnIndex3 = 14;

        const titleTable1 = csv[0]?.[columnIndex1];
        const titleTable2 = csv[0]?.[columnIndex2];
        const titleTable3 = csv[0]?.[columnIndex3];

        const column1 = _csv.map(elem => elem[columnIndex1]);
        const column2 = _csv.map(elem => elem[columnIndex2]);
        const column3 = _csv.map(elem => elem[columnIndex3]);

        const set1 = [];
        const set2 = [];
        const set3 = [];

        const table1 = [[titleTable1, ...header]];
        const table2 = [[titleTable2, ...header]];
        const table3 = [[titleTable3, ...header]];

        const generateTableData = (elem, array, set, table) => {
          const modifiedElem = elem.toLowerCase().trim();
          if (!set.includes(modifiedElem)) {
            set.push(modifiedElem);
            table.push([
              elem || 'n/a',
              getAbsoluteFrequency(elem, array),
              getRelativeFrequency(elem, array).toFixed(2),
              getPercentage(elem, array).toFixed(2) + ' %'
            ]);
          }
        };

        column1.forEach((elem, _, array) => generateTableData(elem, array, set1, table1));
        column2.forEach((elem, _, array) => generateTableData(elem, array, set2, table2));
        column3.forEach((elem, _, array) => generateTableData(elem, array, set3, table3));

        console.log({ table1, table2, table3 });
      }

      reader.readAsText(file);

    }

  </script>
</body>

</html>
